#ifndef _LINUX_UGCI_H
#define _LINUX_UGCI_H

/*
 * /usr/include/linux/ugci.h  Version 0.2
 *
 * Copyright (C) 1999 Adam Wiggins
 */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or 
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#include <asm/types.h>
#include <linux/module.h>

/*
 * Version
 */

#define UGCI_VERSION		0x1

/*
 * Types and constants for reading from /dev/usbugci
 */

#define NUM_START_BTNS	2
#define NUM_GAME_BTNS	11
#define NUM_TB_BTNS	3
#define NUM_BTNS	(NUM_START_BTNS + NUM_GAME_BTNS + NUM_TB_BTNS)

#define BTN_START_1	0
#define BTN_START_2	1
#define BTN_1		2
#define BTN_2		3
#define BTN_3		4
#define BTN_4		5
#define BTN_5		6
#define BTN_6		7
#define BTN_7		8
#define BTN_8		9
#define BTN_9		10
#define BTN_10		11
#define BTN_11		12
#define BTN_TRACKBALL_1	13
#define BTN_TRACKBALL_2	14
#define BTN_TRACKBALL_3	15

#define BTN_START_1_MASK	(1 << BTN_START_1)
#define BTN_START_2_MASK	(1 << BTN_START_2)
#define BTN_1_MASK		(1 << BTN_1)
#define BTN_2_MASK		(1 << BTN_2)
#define BTN_3_MASK		(1 << BTN_3)
#define BTN_4_MASK		(1 << BTN_4)
#define BTN_5_MASK		(1 << BTN_5)
#define BTN_6_MASK		(1 << BTN_6)
#define BTN_7_MASK		(1 << BTN_7)
#define BTN_8_MASK		(1 << BTN_8)
#define BTN_9_MASK		(1 << BTN_9)
#define BTN_10_MASK		(1 << BTN_10)
#define BTN_11_MASK		(1 << BTN_11)
#define BTN_TRACKBALL_1_MASK	(1 << BTN_TRACKBALL_1)
#define BTN_TRACKBALL_2_MASK	(1 << BTN_TRACKBALL_2)
#define BTN_TRACKBALL_3_MASK	(1 << BTN_TRACKBALL_3)

struct ugci_state {
    	__u8 jx, jy;			/* joystick position */
	__s16 tdx, tdy;			/* trackball deltas since last read */
    	__u16 coin_count[2];		/* coindrop counters */
	__u16 buttons;			/* button states (up = 0, down = 1) */
	__u8 pressed_count[16];		/* number of times pressed since last read */
	__u8 released_count[16];	/* number of times released since last read */
};

#endif /* _LINUX_UGCI_H */

